--
-- Mod: Animal Worker
--
-- Author: Tunnelrat
-- @Date: 06.19.2019
-- @Version: 0.0.0.1 -- beta
-- @Version: 2.0 Animal worker automatically tends to animal needs for a daily fee.
-- Copyright (C) Tunnelrat, All Rights Reserved.

animalWorker = {};

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml")

animalWorkerActive = false
animalWorkerFee = 0.05

animalWorker.version = getXMLString(modDesc, "modDesc.version")
animalWorker.modDirectory = g_currentModDirectory

addModEventListener(animalWorker)

function animalWorker:loadMap()

print("############################################################")
print("--- Animal Worker v.:" .. self.version .. ", by Tunnelrat.")
print("############################################################")

-- Settings
inputsActive = false
animalWorker.settingsDir = getUserProfileAppPath().. "modsSettings/animalWorker/"

animalWorker.LoadSettings()
animalWorker.SaveSettings()

end

function animalWorker:SaveSettings()

	createFolder(getUserProfileAppPath() .. "modsSettings/")
	createFolder(animalWorker.settingsDir)
	local file = animalWorker.settingsDir .. "animalWorker.xml"
	local pos = 0
	local rootPath = "animalWorker.settings"
	local groupNameTag = string.format("%s.setting(%d)", rootPath, pos)

	if not fileExists(file) then
		-- create
		local xmlContent = createXMLFile("animalWorker_XML", file, "animalWorker")
		
		setXMLBool(xmlContent, groupNameTag .. "#animalWorkerActive", animalWorkerActive)
		setXMLFloat(xmlContent, groupNameTag .. "#animalWorkerFee", animalWorkerFee)
		setXMLFloat(xmlContent, groupNameTag .. "#costPerAnimal", costPerAnimal)
		saveXMLFile(xmlContent)
	else
		-- update
		local xmlContent = createXMLFile("animalWorker_XML", file, "animalWorker")
		
		setXMLBool(xmlContent, groupNameTag .. "#animalWorkerActive", animalWorkerActive)
		setXMLFloat(xmlContent, groupNameTag .. "#animalWorkerFee", animalWorkerFee)
		setXMLFloat(xmlContent, groupNameTag .. "#costPerAnimal", costPerAnimal)
		saveXMLFile(xmlContent)
	end

end

function animalWorker:LoadSettings()
	
	local file = animalWorker.settingsDir .. "animalWorker.xml"
	
	if fileExists(file) then
		local xmlContent = loadXMLFile("animalWorker_XML", file, "animalWorker")
		
		local pos = 0
		local rootPath = "animalWorker.settings"
		local groupNameTag = string.format("%s.setting(%d)", rootPath, pos)
		
		animalWorkerActive 	= Utils.getNoNil(getXMLBool(xmlContent, groupNameTag .. "#animalWorkerActive"), true)
		animalWorkerFee		= Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#animalWorkerFee"), 0.05)
		costPerAnimal		= Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#costPerAnimal"), 10.00)
	else
		print("Animal Worker XML settings not found.")
	end
	
end

function animalWorker:keyEvent(unicode, sym, modifier, isDown)

end

function animalWorker:mouseEvent(posX, posY, isDown, isUp, button)
end


function animalWorker:deleteMap()
end

function animalWorker:update(dt)

	local hourNow = g_currentMission.environment.currentHour
	local minuteNow = g_currentMission.environment.currentMinute
	--local stats = g_currentMission:farmStats(self:getOwnerFarmId())
	local playerOwnsFarm = false
	
	farmData = {
		ownerFarmId = 0,
		farmId = 0,
	}
	
	local playerOwnsFarm = false
	
	function checkIsOwnerOfFarm(husbandry)
		if g_currentMission:getIsClient() then
			farmData.ownerFarmId = g_currentMission.player.ownerFarmId
			farmData.farmId = g_currentMission.player.farmId
			
			if husbandry.modulesByName.animals.owner.ownerFarmId == farmData.farmId then
				playerOwnsFarm = true
				return true
			else
				playerOwnsFarm = false
				return false
			end
		end
	end
	--[[
	function getFoodFillAmountById(id, husbandry)
		print("infunction: " .. tostring(husbandry))
		if id ~= nil and husbandry ~= nil then
			local capacities = husbandry.modulesByName.food.foodGroupCapacities
			local capacity = 0
			for k, v in pairs(capacities) do
				capacity = capacities[k].capacity
			end
			local fillLevel = tonumber(math.ceil(husbandry.modulesByName.food.fillLevels[id]))
			return capacity
		else
			print("animalWorker:Bad parameters given.")
		end

	end
	]]--
	function animalCount(husbandry)
		if husbandry ~= nil then
			local animals = husbandry.modulesByName.animals.animals
			local numAnimals = 0
			for k,v in pairs(animals) do
				numAnimals = tonumber(k)
			end
			return numAnimals
		else
			print("animalWorker:bad parameters for animalCount()")
			return 0
		end
	end
	--FillTypes concatenated
					local wheat = 2
					local barley = 3
					local canola = 5
					local forage = 19
					local silage = 24
					local hay = 30
					local grass = 28
					local sunflower = 6
					local soybean = 7 -- g_currentMission.fillTypeManager:getFillTypeIndexByName("fillType_soybean")
					local maize = 8
					local oat = 4
					local potato = 9
					local sugerbeet = 10
	local chickens, cows, horse, pigs, sheep, all = 0, 0, 0, 0, 0, 0
	
	-- Fill water troughs, food and straw at 7am if worker is active
	if hourNow == 7 and animalWorkerActive == true then
		
		-- CHICKENS
		for _,husbandry in pairs(g_currentMission.husbandries) do
		
			local animalType = husbandry.modulesByName.animals.animalType
		
			if checkIsOwnerOfFarm(husbandry) == true then
			
				-- Water
				if husbandry.modulesByName.water ~= nil then
					local amountToAdd = husbandry.modulesByName.water:getFreeCapacity(FillType.WATER)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.water:getFillLevel(FillType.WATER)
					capacity = husbandry.modulesByName.water.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.water:setFillLevel(FillType.WATER, capacity)					
					end
				end
			
				-- Straw
				if husbandry.modulesByName.straw ~= nil then
					local amountToAdd = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.straw:getFillLevel(FillType.STRAW)
					capacity = husbandry.modulesByName.straw.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, capacity)
					end
				end
				
				-- Feed Animals
				if animalType ~= nil and animalType == "CHICKEN" then
					
					chickens = animalCount(husbandry)
					if chickens > 0 then
						local wheatToAdd = tonumber(math.floor(3.6 * chickens * 6))
						print("animalWorker: Fed " .. wheatToAdd .. " to " .. chickens .. " chickens.")
						if wheatToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.WHEAT, wheatToAdd)
						end
					end
				end	-- End feeding
			
			end -- owner
		
		end -- for loop chicken
		
		-- COWS
		for _,husbandry in pairs(g_currentMission.husbandries) do
		
			local animalType = husbandry.modulesByName.animals.animalType
		
			if checkIsOwnerOfFarm(husbandry) == true then
			
				-- Water
				if husbandry.modulesByName.water ~= nil then
					local amountToAdd = husbandry.modulesByName.water:getFreeCapacity(FillType.WATER)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.water:getFillLevel(FillType.WATER)
					capacity = husbandry.modulesByName.water.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.water:setFillLevel(FillType.WATER, capacity)					
					end
				end
			
				-- Straw
				if husbandry.modulesByName.straw ~= nil then
					local amountToAdd = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.straw:getFillLevel(FillType.STRAW)
					capacity = husbandry.modulesByName.straw.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, capacity)
					end
				end
				
				if animalType == "COW" then
					cows = animalCount(husbandry)
					if cows > 0 then
						local forageToAdd = tonumber(math.floor(500 * cows * 6))
						if forageToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.FORAGE, forageToAdd)
						end
					end
				end
			end
		end -- for loop cow
		
		-- HORSE
		for _,husbandry in pairs(g_currentMission.husbandries) do
		
			local animalType = husbandry.modulesByName.animals.animalType
		
			if checkIsOwnerOfFarm(husbandry) == true then
			
				-- Water
				if husbandry.modulesByName.water ~= nil then
					local amountToAdd = husbandry.modulesByName.water:getFreeCapacity(FillType.WATER)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.water:getFillLevel(FillType.WATER)
					capacity = husbandry.modulesByName.water.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.water:setFillLevel(FillType.WATER, capacity)					
					end
				end
			
				-- Straw
				if husbandry.modulesByName.straw ~= nil then
					local amountToAdd = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.straw:getFillLevel(FillType.STRAW)
					capacity = husbandry.modulesByName.straw.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, capacity)
					end
				end
				
				if animalType == "HORSE" then
					horse = animalCount(husbandry)
					if horse > 0 then
						local oatToAdd = tonumber(math.floor(88 * horse * 6))
						local hayToAdd = tonumber(math.floor(265 * horse * 6))
						if oatToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.OAT, oatToAdd)
						end
						if hayToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.DRYGRASS_WINDROW, hayToAdd)
						end
					end
				end
			end
		end -- for loop horse
		
		-- PIG
		for _,husbandry in pairs(g_currentMission.husbandries) do
		
			local animalType = husbandry.modulesByName.animals.animalType
		
			if checkIsOwnerOfFarm(husbandry) == true then
			
				-- Water
				if husbandry.modulesByName.water ~= nil then
					local amountToAdd = husbandry.modulesByName.water:getFreeCapacity(FillType.WATER)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.water:getFillLevel(FillType.WATER)
					capacity = husbandry.modulesByName.water.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.water:setFillLevel(FillType.WATER, capacity)					
					end
				end
			
				-- Straw
				if husbandry.modulesByName.straw ~= nil then
					local amountToAdd = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.straw:getFillLevel(FillType.STRAW)
					capacity = husbandry.modulesByName.straw.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, capacity)
					end
				end
				
				if animalType == "PIG" then
					pigs = animalCount(husbandry)
					if pigs > 0 then
						local wheatToAdd = tonumber(math.floor(18 * pigs * 6))
						local canolaToAdd = tonumber(math.floor(15 * pigs * 6))
						local maizeToAdd = tonumber(math.floor(35 * pigs * 6))
						local potatoToAdd = tonumber(math.floor(4 * pigs * 6))
						if wheatToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.WHEAT, wheatToAdd)
						end
						if canolaToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.CANOLA, canolaToAdd)
						end
						if maizeToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.MAIZE, maizeToAdd)
						end
						if potatoToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.POTATO, potatoToAdd)
						end
					end
				end
			end
		end -- for loop pig
		
		-- SHEEP
		for _,husbandry in pairs(g_currentMission.husbandries) do
		
			local animalType = husbandry.modulesByName.animals.animalType
		
			if checkIsOwnerOfFarm(husbandry) == true then
			
				-- Water
				if husbandry.modulesByName.water ~= nil then
					local amountToAdd = husbandry.modulesByName.water:getFreeCapacity(FillType.WATER)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.water:getFillLevel(FillType.WATER)
					capacity = husbandry.modulesByName.water.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.water:setFillLevel(FillType.WATER, capacity)					
					end
				end
			
				-- Straw
				if husbandry.modulesByName.straw ~= nil then
					local amountToAdd = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
					local fillLevel, capacity = 0, 0
    
					fillLevel = husbandry.modulesByName.straw:getFillLevel(FillType.STRAW)
					capacity = husbandry.modulesByName.straw.fillCapacity
		
					if amountToAdd > 0 then
						husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, capacity)
					end
				end
				
				if animalType == "SHEEP" then
					sheep = animalCount(husbandry)
					if sheep > 0 then
						local grassToAdd = tonumber(math.floor(50 * sheep * 6))
						if grassToAdd > 0 then
							husbandry.modulesByName.food:setFillLevel(FillType.GRASS_WINDROW, grassToAdd)
						end
					end
				end
			end
		end -- for loop sheep
		
		all = tonumber(chickens + cows + pigs + horse + sheep)
		
		-- Pay the worker...
		local difficultyMultiplier = g_currentMission.missionInfo.buyPriceMultiplier
		-- local waterCost = g_currentMission.economyManager:getCostPerLiter(FillType.WATER, false)
		local moneyUnit = g_gameSettings.moneyUnit
		if moneyUnit == "1" then
			moneyType = "EUROS"
		elseif moneyUnit == "2" then
			moneyType = "DOLLARS"
		elseif moneyUnit == "3" then
			moneyType = "POUNDS"
		end
		local price = 0
		local farmCost = 0
		if all ~= 0 then
			price = costPerAnimal * all * difficultyMultiplier
			price = price + (price * animalWorkerFee)
			farmCost = round(price, 2)
		end
		if minuteNow == 00 then
			g_currentMission:farmStats(farmData.farmId):updateStats("expenses", price)
			g_currentMission:addMoney(-price, farmData.farmId, MoneyType.ANIMAL_UPKEEP, true)
			print("animalWorker:Ranch hand fed, watered and bedded all " .. all .. " animals at 7am for " .. farmCost .. " " .. moneyType .. ".")
		end
		-- End costs
		
	end
end

function animalWorker:draw()
end